﻿//------------------------------------------------------------------------------
// 2013.12.19 by 龟山阿卍 QQ 1467948783                                        -
// http://www.cnblogs.com/onechen/                                             -
//------------------------------------------------------------------------------

unit Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Objects;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    ToolBar2: TToolBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Popup1: TPopup;
    Button5: TButton;
    Button6: TButton;
    CalloutRectangle1: TCalloutRectangle;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.Button1Click(Sender: TObject);
begin
     // 上左
     Popup1.PlacementTarget  := TButton(Sender);
     Popup1.Placement        := TPlacement.plBottom;
     Popup1.HorizontalOffset := 0;

     CalloutRectangle1.CalloutPosition := TCalloutPosition.cpTop;
     CalloutRectangle1.CalloutOffset   := (TButton(Sender).Width - CalloutRectangle1.CalloutWidth) / 2;
     Popup1.Popup;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
     // 上中
     Popup1.PlacementTarget  := TButton(Sender);
     Popup1.Placement        := TPlacement.plBottom;
     Popup1.HorizontalOffset := -(Popup1.Width - TButton(Sender).Width) / 2;

     CalloutRectangle1.CalloutPosition := TCalloutPosition.cpTop;
     CalloutRectangle1.CalloutOffset   := 0;
     Popup1.Popup;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     // 上右
     Popup1.PlacementTarget  := TButton(Sender);
     Popup1.Placement        := TPlacement.plBottom;
     Popup1.HorizontalOffset := -(Popup1.Width - TButton(Sender).Width);

     CalloutRectangle1.CalloutPosition := TCalloutPosition.cpTop;
     CalloutRectangle1.CalloutOffset   := (Popup1.Width - TButton(Sender).Width) + (TButton(Sender).Width - CalloutRectangle1.CalloutWidth) / 2;
     Popup1.Popup;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     // 下左
     Popup1.PlacementTarget  := TButton(Sender);
     Popup1.Placement        := TPlacement.plTop;
     Popup1.HorizontalOffset := 0;

     CalloutRectangle1.CalloutPosition := TCalloutPosition.cpBottom;
     CalloutRectangle1.CalloutOffset   := (TButton(Sender).Width - CalloutRectangle1.CalloutWidth) / 2;
     Popup1.Popup;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
     // 下中
     Popup1.PlacementTarget  := TButton(Sender);
     Popup1.Placement        := TPlacement.plTop;
     Popup1.HorizontalOffset := -(Popup1.Width - TButton(Sender).Width) / 2;

     CalloutRectangle1.CalloutPosition := TCalloutPosition.cpBottom;
     CalloutRectangle1.CalloutOffset   := 0;
     Popup1.Popup;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     // 下右
     Popup1.PlacementTarget  := TButton(Sender);
     Popup1.Placement        := TPlacement.plTop;
     Popup1.HorizontalOffset := -(Popup1.Width - TButton(Sender).Width);

     CalloutRectangle1.CalloutPosition := TCalloutPosition.cpBottom;
     CalloutRectangle1.CalloutOffset   := (Popup1.Width - TButton(Sender).Width) + (TButton(Sender).Width - CalloutRectangle1.CalloutWidth) / 2;
     Popup1.Popup;
end;

end.
